<?php

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);


require_once 'Class_DataBase.php';

class ShopBotDataBase extends TelegramBotDataBase
{

    public function getListItems($location_id)
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_items` WHERE parent_location = ?");
        $statement->execute([$location_id]);
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            {   
                $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_photos` WHERE parent_id = ?");
                $statement->execute([$chan['id']]);
                $am = $statement->fetchAll();
                if( count($am) > 0 )
                {
                    if(1){ //later check quantity
                        $chanbuffer[] = ['text' => $chan['name'], 'callback_data' => 'itemid:' . $chan['id']];
                    }
                }
            }
            return $chanbuffer;
        }
        return false;
        
    }

    public function getListItemsToUpload()
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_items`");
        $statement->execute([]);
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            { 
                if(1){ //later check quantity

                    $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_locations` WHERE id = ?");
                    $statement->execute([$chan['parent_location']]);
                    $data = $statement->fetch();

                    $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_cities` WHERE id = ?");
                    $statement->execute([$data['parent_city']]);
                    $data2 = $statement->fetch();
                    
                    
                    $chanbuffer[] = ['text' => $chan['name'] . ' | ' . $data['name'] . ' - ' . $data2['name'], 'callback_data' => 'itemidupload:' . $chan['id']];
                }
            }
        }
        return $chanbuffer;
    }

    public function setUsername($user_id, $status)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET name = ? WHERE id = ?");
        $statement->execute([$status, $user_id]);
    }
     

    

    public function getListCities()
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_cities`");
        $statement->execute();
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            {   
                if (count($this->getListLocations($chan['id'])) > 0 ){
                    $chanbuffer[] = ['text' => $chan['name'], 'callback_data' => 'cityid:' . $chan['id']];
                }
            }
            return $chanbuffer;
        }
        return false;
    }

    public function getListCitiesLoc()
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_cities`");
        $statement->execute();
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            {   
                $chanbuffer[] = ['text' => $chan['name'], 'callback_data' => 'choosecity:' . $chan['id']];
            }
            return $chanbuffer;
        }
        return false;       
    }

    public function getListCitiesDel()
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_cities`");
        $statement->execute();
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            {   
                $chanbuffer[] = ['text' => $chan['name'], 'callback_data' => 'delcity:' . $chan['id']];
            }
            return $chanbuffer;
        }
        return false;       
    }

    public function getListProductsDel()
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_items`");
        $statement->execute();
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            {   
                $chanbuffer[] = ['text' => $chan['name'], 'callback_data' => 'delitem:' . $chan['id']];
            }
            return $chanbuffer;
        }
        return false;       
    }


    public function getListLocsDel()
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_locations`");
        $statement->execute();
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            {   
                $chanbuffer[] = ['text' => $chan['name'], 'callback_data' => 'delloc:' . $chan['id']];
            }
            return $chanbuffer;
        }
        return false;       
    }



    public function getListCitiesItem()
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_cities`");
        $statement->execute();
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            {   
                
                $chanbuffer[] = ['text' => $chan['name'], 'callback_data' => 'itemcity:' . $chan['id']];
            }
            return $chanbuffer;
        }
        return false;       
    }

    public function getListLocations($city_id)
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_locations` WHERE parent_city = ?");
        $statement->execute([$city_id]);
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            { 
                if (count($this->getListItems($chan['id'])) > 0 ){
                    $chanbuffer[] = ['text' => $chan['name'], 'callback_data' => 'locationid:' . $chan['id']];
                }
                
            }
            return $chanbuffer;
        }
        return false;
    }

    public function getListLocationsItem($city_id)
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_locations` WHERE parent_city = ?");
        $statement->execute([$city_id]);
        $chanbuffer = [];
        $data = $statement->fetchAll();
        if( count($data) > 0 )
        {
            foreach($data as $chan)
            {   
                $chanbuffer[] = ['text' => $chan['name'], 'callback_data' => 'itemlocation:' . $chan['id']];
            }
            return $chanbuffer;
        }
        return false;      
    }


    public function getPromo($id){
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_promocodes` WHERE name = ?");
        $statement->execute([$id]);
        $data = $statement->fetch();
        return $data;
    }

    
    public function getItem($id){
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_items` WHERE id = ?");
        $statement->execute([$id]);
        $data = $statement->fetch();
        return $data;
    }

    public function getUse($uid, $promo){
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_promouses` WHERE name = ? AND uid = ?");
        $statement->execute([$promo, $uid]);
        $data = $statement->fetch();
        return $data;
    }

    public function getReviews(){
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_reviews`");
        $statement->execute();
        $data = $statement->fetchAll();
        return $data;
    }

    public function getSoldPhoto($quantity, $id){
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_photos` WHERE quantity = ? AND parent_id = ? LIMIT 1");
        $statement->execute([$quantity, $id]);
        $data = $statement->fetch();
        return $data;
    }

    public function deleteSoldPhoto($id){
        $statement = $this->pdo->prepare("DELETE FROM `TELESHOPv2_photos` WHERE id = ?");
        $statement->execute([$id]);
    }

    public function deleteReview($id){
        $statement = $this->pdo->prepare("DELETE FROM `TELESHOPv2_reviews` WHERE id = ?");
        $statement->execute([$id]);
    }

    public function deleteLocation($id){
        $statement = $this->pdo->prepare("DELETE FROM `TELESHOPv2_locations` WHERE id = ?");
        $statement->execute([$id]);
    }

    public function deleteCity($id){
        $statement = $this->pdo->prepare("DELETE FROM `TELESHOPv2_cities` WHERE id = ?");
        $statement->execute([$id]);

        $statement = $this->pdo->prepare("DELETE FROM `TELESHOPv2_locations` WHERE parent_city = ?");
        $statement->execute([$id]);
    }


    public function getAmount($id, $amount){
        $statement = $this->pdo->prepare("SELECT count(*) FROM `TELESHOPv2_photos` WHERE parent_id = ? AND quantity = ?");
        $statement->execute([$id, $amount]);
        $data = $statement->fetch();
        return $data;
    }

    public function getBalance($userid){

        $statement = $this->pdo->prepare("SELECT balance FROM `TELESHOPv2_users` WHERE id = ?");
        $statement->execute([$userid]);
        $data = $statement->fetch();
        return $data['balance'];

    }

    public function getOrders($userid){

        $statement = $this->pdo->prepare("SELECT orders FROM `TELESHOPv2_users` WHERE id = ?");
        $statement->execute([$userid]);
        $data = $statement->fetch();
        return $data['orders'];

    }

    public function getSetting($setting){

        $statement = $this->pdo->prepare("SELECT amount FROM `TELESHOPv2_settings` WHERE name = ?");
        $statement->execute([$setting]);
        $data = $statement->fetch();
        return $data;

    }

    public function getLocation($id){

        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_locations` WHERE id = ?");
        $statement->execute([$id]);
        $data = $statement->fetch();
        return $data;

    }

    public function getCity($id){

        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_cities` WHERE id = ?");
        $statement->execute([$id]);
        $data = $statement->fetch();
        return $data;

    }

    
    
    public function lastItemBot(){

        $statement = $this->pdo->prepare("SHOW CREATE TABLE `TELESHOPv2_items`");
        $statement->execute();
        $data = $statement->fetch();
        $data = $data['Create Table'];
        $data = stristr($data, 'AUTO_INCREMENT=');
        $data = stristr($data, ' DEFAULT', True);
        $data = explode('=', $data);
        return $data[1];

    }
    
    public function getLanguage($userid){

        $statement = $this->pdo->prepare("SELECT lang FROM `TELESHOP_users` WHERE id = ?");
        $statement->execute([$userid]);
        $data = $statement->fetch();
        return $data['lang'];

    }

    public function getUsers(){

        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_users`");
        $statement->execute();
        $data = $statement->fetchAll();
        return $data;

    }

    public function getUsersOrderBy(){

        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_users` ORDER BY orders DESC");
        $statement->execute();
        $data = $statement->fetchAll();
        return $data;

    }

    public function getItems(){

        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_items`");
        $statement->execute();
        $data = $statement->fetchAll();
        return $data;

    }

    public function addBalance($userid, $amount){

        $current = (float) $this->getBalance($userid);
        $new = $current + $amount;
        $statement = $this->pdo->prepare("UPDATE `TELESHOPv2_users` SET balance = ? WHERE id = ?;");
        $statement->execute([$new, $userid]);
        $data = $statement->fetch();
        return $data;

    }

    public function usePromo($promo){

        $current = $this->getPromo($promo);
        $new = (int) $current['times'] - 1;
        $statement = $this->pdo->prepare("UPDATE `TELESHOPv2_promocodes` SET times = ? WHERE name = ?;");
        $statement->execute([$new, $promo]);
        $data = $statement->fetch();
        return $data;

    }

    public function wipeBalances(){


        $statement = $this->pdo->prepare("UPDATE `TELESHOPv2_users` SET balance = 0");
        $statement->execute();
        $data = $statement->fetch();
        return $data;

    }

    public function addBonus($userid, $amount){

        $current = (float) $this->getUser($userid)['bonus'];
        $new = $current + $amount;
        $statement = $this->pdo->prepare("UPDATE `TELESHOPv2_users` SET bonus = ? WHERE id = ?;");
        $statement->execute([$new, $userid]);
        $data = $statement->fetch();
        return $data;

    }

    public function addOrder($userid, $amount){

        $current = (int) $this->getUser($userid)['orders'];
        $new = $current + $amount;
        $statement = $this->pdo->prepare("UPDATE `TELESHOPv2_users` SET orders = ? WHERE id = ?;");
        $statement->execute([$new, $userid]);
        $data = $statement->fetch();
        return $data;

    }

    public function minusBalance($userid, $amount){

        $current = (int) $this->getBalance($userid);
        $new = $current - $amount;
        $statement = $this->pdo->prepare("UPDATE `TELESHOP_users` SET balance = ? WHERE id = ?;");
        $statement->execute([$new, $userid]);
        $data = $statement->fetch();
        return $data;

    }

    public function setSold($id, $status)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOP_items SET is_Sold = ? WHERE id = ?");
        $statement->execute([$status, $id]);
    }

    public function setPercent($amount)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_settings SET amount = ? WHERE `name` = 'referal_percent'");
        $statement->execute([$amount]);
    }

    public function setCurrency($amount, $name)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_settings SET amount = ? WHERE `name` = ?");
        $statement->execute([$amount, $name]);
    }

    public function getLocationName($id)
    {
        $statement = $this->pdo->prepare("SELECT name FROM `TELESHOPv2_locations` WHERE id = ?");
        $statement->execute([$id]);
        $data = $statement->fetch();
        return $data['name'];
    }

    public function getID($username)
    {
        $statement = $this->pdo->prepare("SELECT `id` FROM `TELESHOPv2_users` WHERE `name` = ?");
        $statement->execute([$username]);
        $data = $statement->fetch();
        return $data['id'];
    }


    
    

    public function setReviewText($id, $text)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_reviews SET comment = ? WHERE id = ?");
        $statement->execute([$text, $id]);
    }

    public function setLanguage($userid, $lang){

        $statement = $this->pdo->prepare("UPDATE `TELESHOP_users` SET lang = ? WHERE id = ?;");
        $statement->execute([$lang, $userid]);
        $data = $statement->fetch();
        return $data;

    }

    public function addUser($user_id, $user_name)
    {
        $checkstatement = $this->pdo->prepare("SELECT id FROM `TELESHOPv2_users` WHERE id = ?");
        $checkstatement->execute([$user_id]);
        $data = $checkstatement->fetch();
        // array(1) { ["id"]=> string(1) "1" } OR bool(false)
        if($data === false)
        {
            $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_users` (`id`, `name`, `balance`, `orders`, `discount`, `invited`, `bonus`, `status`, `quantity`, `referal`) VALUES (:id, :username, 0, 0, 0, 0, 0, '0', '0', '0');");
            if($statement->execute(['id' => $user_id, 'username' => $user_name]))
            {
                return true;
            }
            else
            {
                file_put_contents(__DIR__ . '/dbErrors.txt', print_r($statement, 1), FILE_APPEND);
                return false;
            }
        }
        return 'Уже добавлен';
    }

    public function addReview($user_id, $user_name, $rate)
    {
        $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_reviews` (`id`, `rating`, `comment`, `author_un`, `author_id`) VALUES (NULL, :rate, '', :username, :id)");
        $statement->execute(['rate' => $rate, 'username' => $user_name, 'id' => $user_id,]);
    }

    public function addUse($user_id, $promo)
    {
        $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_promouses` (`name`, `uid`) VALUES (:promo, :uid)");
        $statement->execute(['promo' => $promo, 'uid' => $user_id]);
    }

    public function addReviewWithText($user_id, $user_name, $rate, $text)
    {
        $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_reviews` (`id`, `rating`, `comment`, `author_un`, `author_id`) VALUES (NULL, :rate, :comment, :username, :id)");
        $statement->execute(['rate' => $rate, 'username' => $user_name, 'id' => $user_id, 'comment' => $text]);
    }

    public function addUserRef($user_id, $user_name, $referal)
    {
        $checkstatement = $this->pdo->prepare("SELECT id FROM `TELESHOPv2_users` WHERE id = ?");
        $checkstatement->execute([$user_id]);
        $data = $checkstatement->fetch();
        // array(1) { ["id"]=> string(1) "1" } OR bool(false)
        if($data === false)
        {
            $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_users` (`id`, `name`, `balance`, `orders`, `discount`, `invited`, `bonus`, `status`, `quantity`, `referal`) VALUES (:id, :username, 0, 0, 0, 0, 0, '0', '0', :referal);");
            if($statement->execute(['id' => $user_id, 'username' => $user_name, 'referal' => $referal]))
            {
                return true;
            }
            else
            {
                file_put_contents(__DIR__ . '/dbErrors.txt', print_r($statement, 1), FILE_APPEND);
                return false;
            }
        }
        return 'Уже добавлен';
    }

    public function getUser($id){
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_users` WHERE id = ?");
        $statement->execute([$id]);
        $data = $statement->fetch();
        return $data;
    }

    public function deleteItem($id){
        $statement = $this->pdo->prepare("DELETE FROM `TELESHOPv2_items` WHERE id = ?");
        $statement->execute([$id]);
    }

    public function setStatus($user_id, $status)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET status = ? WHERE id = ?");
        $statement->execute([$status, $user_id]);
    }

    public function setDiscount($user_id, $status)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET discount = ? WHERE id = ?");
        $statement->execute([$status, $user_id]);


    }

    public function resetDiscount()
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET discount = 0");
        $statement->execute([]);


    }
    // public function setDiscountGlobal($status, $time)
    // {

    //     $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET discount = ? WHERE discount = 0");
    //     $statement->execute([$status]);

    //     $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET disc_date = ? WHERE discount = 0");
    //     $statement->execute([$time]);

    // }

    public function setDiscTime($user_id, $status)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET disc_date = ? WHERE id = ?");
        $statement->execute([$status, $user_id]);


    }

    public function setInvited($user_id, $amount)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET invited = ? WHERE id = ?");
        $statement->execute([$amount, $user_id]);
    }


    public function setQuantity($user_id, $quantity)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET quantity = ? WHERE id = ?");
        $statement->execute([$quantity, $user_id]);
    }

    public function getStatus($userid)
    {
        $statement = $this->pdo->prepare("SELECT status FROM `TELESHOPv2_users` WHERE id = ?");
        $statement->execute([$userid]);
        $data = $statement->fetch();
        return $data['status'];
    }

    public function getQuantity($userid)
    {
        $statement = $this->pdo->prepare("SELECT quantity FROM `TELESHOPv2_users` WHERE id = ?");
        $statement->execute([$userid]);
        $data = $statement->fetch();
        return $data['quantity'];
    }

    public function getLastReview($userid)
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOPv2_reviews` WHERE author_id = ? ORDER BY id DESC LIMIT 1");
        $statement->execute([$userid]);
        $data = $statement->fetch();
        return $data;
    }

    public function addCity($name)
    {
        $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_cities` (`id`, `name`) VALUES (NULL, :name);");
        return $statement->execute(['name' => $name]);
    }

    public function addLocation($name, $parentid)
    {
        $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_locations` (`id`, `name`, `parent_city`) VALUES (NULL, :name, :parentid);");
        return $statement->execute(['name' => $name, 'parentid' => $parentid]);
    }

    public function addItem($name, $description_photo, $parent_location, $price05, $price1, $price2, $price5, $sold_text, $description_text)
    {
        $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_items` (`id`, `name`, `parent_location`, `price05`, `price1`, `price2`, `price5`, `description_text`, `sold_text`, `description_photo`) VALUES (NULL, :name, :parent_location, :price05, :price1, :price2, :price5, :description_text, :sold_text, :description_photo);");
        $statement->execute(['name' => $name, 'parent_location' => $parent_location, 'price05' => $price05, 'price1' => $price1, 'price2' => $price2, 'price5' => $price5, 'description_text' => $description_text, 'sold_text' => $sold_text, 'description_photo' => $description_photo]);
    }

    public function addPhoto($file_id, $parent_id, $quantity)
    {
        $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_photos` (`parent_id`, `file_id`, `id`, `quantity`) VALUES (:parent_id, :file_id, NULL, :quantity);");
        return $statement->execute(['parent_id' => $parent_id, 'file_id' => $file_id, 'quantity' => $quantity]);
    }

    public function setNextOperationBalanceUp($user_id, $currency)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOPv2_users SET next_balanceup = 1, up_currency = ? WHERE id = ?");
        $statement->execute([$currency, $user_id]);
    }

    public function unsetNextOperationBalanceUp($user_id)
    {
        $statement = $this->pdo->prepare("UPDATE TELESHOP_users SET next_balanceup = 0, up_currency = 0 WHERE id = ?");
        $statement->execute([$user_id]);
    }
    public function checkNextOperationBalanceUp($user_id)
    {
        $statement = $this->pdo->prepare("SELECT next_balanceup, up_currency FROM TELESHOP_users WHERE id = ?");
        $statement->execute([$user_id]);
        $data = $statement->fetch();
        return $data;
    }

    public function addPromo($name, $amount, $uses)
    {
        $statement = $this->pdo->prepare("INSERT INTO `TELESHOPv2_promocodes` (`name`, `amount`, `times`) VALUES (:name, :amount, :uses)");
        $statement->execute(['name' => $name, 'amount' => $amount, 'uses' => $uses]);
        return true;
    }


    // APIRONE 

    public function addInvoice($user_id, $invoice_id, $invoice_status, $invoice_amount, $invoice_role, $invoice_currency, $message_id)
    {
        $statement = $this->pdo->prepare("INSERT INTO `TELESHOP_invoices` (`user_id`, `id`, `in_status`, `amount`, `role`, `currency`, `time_to_expire`, `message_id`) VALUES (:user_id, :invoice_id, :invoice_status, :invoice_amount, :invoice_role, :invoice_currency, current_timestamp(), :message_id)");
        $statement->execute([
            'user_id' => $user_id,
            'invoice_id' => $invoice_id,
            'invoice_status' => $invoice_status,
            'invoice_amount' => $invoice_amount,
            'invoice_role' => $invoice_role,
            'invoice_currency' => $invoice_currency,
            'message_id' => $message_id
        ]);
        return true;
    }

    public function getInvoice($invoice_id)
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOP_invoices` WHERE id = ?");
        $statement->execute([$invoice_id]);
        $data = $statement->fetch();
        return $data;
    }
    public function setStatusInvoice($user_id, $invoice_id, $status_handler)
    {
    $url = "UPDATE `TELESHOP_invoices` SET in_status = " . "'". $status_handler . "'" . 'WHERE user_id = ? AND id = ?;';
    $statement = $this->pdo->prepare($url);
    $statement->execute([$user_id, $invoice_id]);
    }

    public function getInvoiceByUserID($user_id)
    {
        $statement = $this->pdo->prepare("SELECT * FROM `TELESHOP_invoices` WHERE TIMESTAMPDIFF(MINUTE, time_to_expire, NOW()) > 2 AND user_id = ?");
        $statement->execute([$user_id]);
        $data = $statement->fetchAll();
        return $data;
    }
} 


// $DB = new ShopBotDataBase'localhost', 'dossicom_main', 'F[s(i8A,[8zg52', 'dossicom_TELESHOP';
// $text = ['chat_id' => 5678, 'message_id' => 453];

// // $b = $a->getItem(31);
// var_dump($a->addInvoice(623574456, 'qlgN3JX2NitgOb24', 'created', '10000', 'balance_up', 'btc'));
// $a->setStatusInvoice(623574456, 'bNA6gzypxXefV1ed', 'expired');

// $a->setNextOperationBalanceUp(623574456, 'bt');
// $a->unsetNextOperationBalanceUp(623574456);
// $b = $a->checkNextOperationBalanceUp(623574456);
// var_dump($b);
// $a->addInvoice(23, 23, 23, 23, 'o');

